﻿/**
 * Background
 * Author: codelite
 * Description: background object
 */
package  codelite
{
	/** flash classes **/
	import flash.display.Sprite;
	import flash.filters.BlurFilter;
	import flash.events.Event;
	
	/** custom classes **/
	import codelite.utils.Public;

	public class Background extends Sprite
	{
		private var _cells:Array = null;	// array of cell objects
	
		/** constructor **/
		public function Background()
		{
			_cells = [];
			
			// fills the background
			this.graphics.beginFill(0xFFFFFF);
			this.graphics.drawRect(0,0,Public.ReturnStage().stageWidth,Public.ReturnStage().stageHeight);
			this.graphics.endFill();
			
			var $scale   :int = 0;
			var $border  :int = 0;
			var $counter :int = 0;
			
			// depth of field
			var $3rd = 60*50/100;
			var $2nd = 30*50/100;
			var $1st = 10*50/100;
			
			// create the cells for the background
			for (var a:int=0; a<50; a++)
			{
				$scale  = Math.random() * (17 - 9) + 9;
				$border = Math.round(Math.random() * (4 - 2) + 2);
				
				_cells[a]= new BackgroundCell($scale,0x66CCFF,$border,0x0099CC);
				
				if($counter < $1st)
				{
					_cells[a].filters=[new BlurFilter(8,8,8)]
					_cells[a].alpha = Math.random() * (0.3 - 0.1) + 0.1;
					addChildAt(_cells[a], numChildren);
				}
				
				if($counter > $1st && $counter < $2nd)
				{
					_cells[a].filters=[new BlurFilter(6,6,6)]
					_cells[a].alpha = Math.random() * (0.6 - 0.4) + 0.4;
					addChildAt(_cells[a], numChildren);
				}
				
				if($counter > $2nd && $counter < $3rd)
				{
					_cells[a].filters=[new BlurFilter(4,4,4)]
					_cells[a].alpha = Math.random() * (0.8 - 0.6) + 0.6;
					addChildAt(_cells[a], numChildren);
				}
				
				$counter++;

			 }
			 
			 // event listener for anmation
			 addEventListener(Event.ENTER_FRAME, Update, false,0,true);
		}
		
		/** needed for the shake efect **/
		private function MinusOrPlus():int
		{
			var $rand : int = Math.round(Math.random()*(1-0)+0);
			var $val:int = 0;
			
			if ($rand == 1) $val =-1;
			else $val = 1;
			
			return $val;
		}
		
		/** updates the display **/
		private function Update($e:Event):void
		{
			for (var a:int=0; a<50; a++)
			{
				_cells[a].x = _cells[a].ReturnPosX()+ MinusOrPlus()*(Math.random()*0.3);
			    _cells[a].y = _cells[a].ReturnPosY()+ MinusOrPlus()*(Math.random()*0.3);
			}
		}
	}
}