﻿/**
 * BackgroundCell
 * Author: codelite
 * Description: cell object used in the background
 */
package codelite
{
	/** flash classes  **/
	import flash.display.Shape
	
	/** custom classes  **/
	import codelite.utils.Public;
	
	public class BackgroundCell extends Shape
	{
		private var   _posX :Number = 0;	// x positon
		private var   _posY :Number = 0;	// y positon
		
		/** constructor
			@param: $radius - the radius of the cell
			@param: $fill   - the fill color of the cell
			@param: $radius - the radius of the cell
			@param: $border_color - the border color of the cell
			@param: $border - the border size
		**/
		public function BackgroundCell($radius:int, $fill:int, $border:int,$border_color:int)
		{
			//  creates the object
			this.graphics.clear();
			this.graphics.beginFill($fill);
			this.graphics.lineStyle($border, $border_color);
			this.graphics.drawCircle(0,0,$radius);
			this.graphics.endFill();
			
			// position of this object
			_posX = (Math.random() * Public.ReturnStage().stageWidth)-10;
			_posY = (Math.random() * Public.ReturnStage().stageHeight)-10;
			
			this.x = _posX;
			this.y = _posY;
		}
		
		/** return the x pos **/
		public function ReturnPosX():Number { return _posX; }
		/** return the y pos **/
		public function ReturnPosY():Number { return _posY; }
	}
}