﻿/**
 * Display
 * Author: codelite
 * Description: display class
 */
package codelite
{
	/** flash classes **/
	import flash.display.Sprite;
	import flash.events.MouseEvent;

	/** custom classes **/
	import codelite.utils.Public;
	
	public class Display extends Sprite
	{
		private var _bgr		:Background 		= null; // background instance
		private var _menu		:Menu 				= null; // menu class instance
		private var _newgame	:NewGame 			= null; // new game class instance
		private var _gameOver	:GameOverScreen 	= null; // game over class intance
		private var _howTo		:HowToPlayTheGame 	= null; // how to play instance
		
		/** constructor **/
		public function Display()
		{
			// new background
			_bgr = new Background();
			addChild(_bgr);
			
			// new menu
			_menu = new Menu(this)
			addChild(_menu);
		}
		
		/** display in-game section **/
		public function Play($e:MouseEvent):void
		{
			RemoveMenu();
			
			_newgame = new NewGame();
			addChild(_newgame);
		}
		
		/** display try again section **/
		public function TryAgain($e:MouseEvent):void
		{
			removeChild(_gameOver);
			_gameOver.Clear();
			_gameOver = null;
			
			_newgame = new NewGame();
			addChild(_newgame);
		}

		/** display game over section **/
		public function GameOver($score:int):void
		{
			removeChild(_newgame);
			_newgame.Clear();
			_newgame = null;
			
			_gameOver = new GameOverScreen(this, $score);
			addChild(_gameOver)
		}
		
		/** display how to play section **/
		public function HowToPlay($e:MouseEvent):void
		{
			RemoveMenu();
			
			_howTo = new HowToPlayTheGame(this);
			addChild(_howTo)
		}
		
		/** display the menu **/
		public function ReturnToMenu($e:MouseEvent):void
		{
			if(_howTo)
			{
				removeChild(_howTo);
				_howTo.Clear();
				_howTo = null;
			}else if(_gameOver){
				removeChild(_gameOver);
				_gameOver.Clear();
				_gameOver = null;
			}
			
			_menu = new Menu(this)
			addChild(_menu);
			
		}
		
		/**  removes the menu  **/
		private function RemoveMenu():void
		{
			removeChild(_menu);
			_menu.Clear();
			_menu = null;
		}
	}
}