﻿/**
 * GameOverScreen
 * Author: codelite
 * Description: game over display elements
 */
package codelite
{
	/** flash classes **/
	import flash.display.Sprite;
	import flash.events.MouseEvent;

	/** custom classes **/
	import codelite.utils.Public;
	import codelite.utils.TextLabel;
	import codelite.utils.CustomGlow;
	
	public class GameOverScreen extends Sprite
	{
		private var _title		:TextLabel 	= null;	// section title
		private var _text 		:TextLabel 	= null;	// text
		private var _menuBtn 	:TextLabel 	= null;	// back to menu button
		private var _tryBtn 	:TextLabel 	= null;	// try again button
		private var _parent 	:Display   	= null;	// display class reference
		
		/** constructor
			@param: $display - display class reference
		**/
		public function GameOverScreen($display:Display,$score:int)
		{
			// set the reference
			_parent = $display;
			
			// new title instance
			_title = new TextLabel();
			_title.SetFormat(70,0xFF6B00,  true, "center");
			_title.SetText("Game Over");
			_title.x = Public.ReturnStage().stageWidth/2 - _title.width/2;
			_title.y = 50;
			CustomGlow.Glow(_title,0x000000);
			addChild(_title);
			
			// new text instance
			_text = new TextLabel();
			_text.SetFormat(27,0xF68B1F,  false, "center", false, false, 450, 5);
			_text.SetText("Your final score is: " + $score);
			_text.x = Public.ReturnStage().stageWidth/2 - _text.width/2;
			_text.y = 150;
			CustomGlow.Glow(_text,0x000000);
			addChild(_text);
			
			// new try again button 
			_tryBtn = new TextLabel();
			_tryBtn.SetFormat(27,0xFF6B00,  false, "center", false, false, 450, 5);
			_tryBtn.SetText("try again");
			_tryBtn.x = Public.ReturnStage().stageWidth/2 - _tryBtn.width/2;
			_tryBtn.y = 230;
			CustomGlow.Glow(_tryBtn,0x000000);
			_tryBtn.buttonMode = true;
			_tryBtn.addEventListener(MouseEvent.CLICK, _parent.TryAgain, false, 0, true);
			addChild(_tryBtn);
			
			// new menu button instance
			_menuBtn = new TextLabel();
			_menuBtn.SetFormat(27,0xFF6B00,  false, "center", false, false, 450, 5);
			_menuBtn.SetText("back to menu");
			_menuBtn.x = Public.ReturnStage().stageWidth/2 - _menuBtn.width/2;
			_menuBtn.y = 270;
			CustomGlow.Glow(_menuBtn,0x000000);
			_menuBtn.buttonMode = true;
			_menuBtn.addEventListener(MouseEvent.CLICK, _parent.ReturnToMenu, false, 0, true);
			addChild(_menuBtn);
		}
		
		
		/** clears this from memory **/
		public function Clear():void
		{
			_tryBtn.removeEventListener(MouseEvent.CLICK, _parent.TryAgain);
			
			
			removeChild(_title);
			_title.Clear();
			_title = null;
			
			removeChild(_text);
			_text.Clear();
			_text = null;
			
			removeChild(_tryBtn);
			_tryBtn.Clear();
			_tryBtn = null;
			
			removeChild(_menuBtn);
			_menuBtn.Clear();
			_menuBtn = null;
		}
	}
}